package cn.com.ty.lift.business.framework.conf;

import com.alibaba.fastjson.parser.DefaultJSONParser;
import com.alibaba.fastjson.parser.JSONLexer;
import com.alibaba.fastjson.parser.JSONToken;
import com.alibaba.fastjson.parser.deserializer.ObjectDeserializer;

import java.lang.reflect.Type;
import java.math.BigDecimal;

/**
 * BigDecimal反序列化
 *
 * @author wcz
 * @since 2020/4/26
 */
public class BigDecimalDeserializer implements ObjectDeserializer {
    @Override
    public <T> T deserialze(DefaultJSONParser parser, Type type, Object fieldName) {
        final JSONLexer lexer = parser.lexer;
        if(type != BigDecimal.class){
            return (T) lexer.numberString();
        }
        BigDecimal bigDecimal = lexer.decimalValue();
        return (T) bigDecimal.setScale(2, BigDecimal.ROUND_HALF_UP);
    }

    @Override
    public int getFastMatchToken() {
        return JSONToken.LITERAL_INT;
    }
}
